-- Visitor Radar
-- by Jadya EU - Well of Eternity
-- communication
local addonName, addonTable = ...
local addon = VisitorRadar

-- message prefixes
local gvr_pref = "##GVRDATA##"
RegisterAddonMessagePrefix("##GVRDATA##")

local function sendmsg(s, chan, target)
 SendAddonMessage(gvr_pref, s, chan, target)
end

local function processmsg(s, ...)
 local input = {strsplit("@", s)}
 local character = select(2,...)

 -- this character doesn't want to show his visitor
 if input[1] == "hide" then
  VisitorRadar_CharData[character] = nil
  addonTable:ToggleButton(character, true)
  return
 elseif input[1] == "data" then
  if not VisitorRadar_CharData[character] then
   VisitorRadar_CharData[character] = {}
  end
 
  local ct = VisitorRadar_CharData[character]

  local _, vid, quests, tamer = unpack(input)
  if vid then vid = tonumber(vid) end
  if quests == "" then 
   quests = nil 
  else
   quests = {strsplit("#", quests)}
  end
  
  -- tell the guildroster frame that a character button needs to be shown
  addonTable:ToggleButton(character)
  
--  if ct.visitor and ct.visitor.id == vid and ct.t > time() then return end

  if not ct.visitor then ct.visitor = {} end
  ct.visitor.id = vid
  ct.visitor.quests = quests
  ct.pet_tamer = tamer == "true" and true or false
  ct.t = time() + GetQuestResetTime()
 end
end

local lastpulse = 0
function addon:Pulse()
 local t = time()
 if lastpulse > t - 2 then return end
 
 -- invisible to guild
 if VisitorRadar_Options and VisitorRadar_Options["noguild"] then
  sendmsg("hide@", "GUILD")
  return
 end
 
 local _, vid, quests, tamer = addon:GetCharacterData(addon.pID)
 tamer = tamer and "true" or ""
 if vid then
  if quests then quests = table.concat(quests, "#") end
  
  local output = "data@"..vid.."@"..(quests or "").."@"..tamer
  sendmsg(output, "GUILD")
 end
 lastpulse = t
end

addon.eventframe:RegisterEvent("CHAT_MSG_ADDON")
function addon.eventframe.CHAT_MSG_ADDON(pref, ...)
 if pref == gvr_pref then
  processmsg(...)
 end
end